﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Browser;

namespace InteropDemo2
{
    public partial class Page : UserControl
    {
        private ScriptObject _other = null;
        private bool _dragging = false;
        private Point _pos;

        private ScriptObject OtherControl
        {
            get
            {
                if (_other == null)
                {
                    HtmlElement targetControl = HtmlPage.Document.GetElementById("TargetControl");
                    ScriptObject targetContent = (ScriptObject)targetControl.GetProperty("content");
                    _other = (ScriptObject)targetContent.GetProperty("other");
                }
                return _other;
            }
        }
        
        public Page()
        {
            InitializeComponent();
        }

        private void Ball_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            _dragging = true;
            _pos = e.GetPosition(null);
        }

        private void Ball_MouseMove(object sender, MouseEventArgs e)
        {
            if (_dragging)
            {
                Point pos = e.GetPosition(null);
                double x = (double)Ball.GetValue(Canvas.LeftProperty) + pos.X - _pos.X;
                double y = (double)Ball.GetValue(Canvas.TopProperty) + pos.Y - _pos.Y;
                Ball.SetValue(Canvas.LeftProperty, x);
                Ball.SetValue(Canvas.TopProperty, y);
                _pos = pos;

                OtherControl.Invoke("MoveBall", x, y);
            }
        }

        private void Ball_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            _dragging = false;
        }

        private void Ball_MouseLeave(object sender, MouseEventArgs e)
        {
            _dragging = false;
        }
    }
}
